// Thundersomething extension for Mozilla Thunderbird
// Copyright (C) 2008 derDoc (derdoc.info)
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.


var Vendor = '';
var ShortName = '';
var	TitleComment = '';
var	TitleName= '';
var Seperator = ' - ';
var LastTitle = 'DonnerVogel';
var LastSep = '-';


var TS_NameManager = {

	//this array was made possible in part by Wikipedias article about 1337-speak (http://en.wikipedia.org/wiki/1337_speak)
	
	tr1337: {
		
		'a'		:  	[ [ '@', '4' ], 		[ "/\\", "/-\\", "^", "aye", '∂', "ci" ] ],
		'b'		:	[ [ '8', '6' ], 		[ "13", "I3", "|3", "ß", "P>", "|:", "!3", "(3", "/3", ")3", "∞", "]3" ] ],
		'c'		:	[ [ '©' ], 				[ '[', '¢', '<', '(', '{', ] ],
		'd'		:	[ [  ], 				[ ')', "|o", "])", "[)", "I>", "|>", "?", "T)", "|)", '0', "ð", "cl" ] ],
		'e'		:	[ [ '3', '&' ], 		[ "€", "£", "ë", "[-", "|=-" ] ],
		'f'		:	[ [  ], 				[ "|=", "ƒ", "|#", "ph", "/=", "-7" ] ],
		'g'		:	[ [ '6', '9' ], 		[ '&', "(_+", "C-", "gee", "(γ,", "(_-", "cj" ] ],
		'h'		:	[ [  ], 				[ "/-/", "[-]", "]-[", ")-(", "(-)", ":-:", "|~|", "|-|", "]~[", "}{", "?", "}-{", "#" ] ],
		'i'		:	[ [ '1', '!', '|' ], 	[ "eye", "3y3", "¡", ']' ] ],
		'j'		:	[ [  ], 				[ "_|", "_/", "]", "¿", "</", "(/", "ʝ" ] ],
		'k'		:	[ [ 'x' ],				[ "|<", "|{", "ɮ" ] ],
		'l'		:	[ [ '1', '|' ],			[ "£", "1_", "|_", "lJ", "¬" ] ],
		'm'		:	[ [  ],					[ "|v|", "em", "]V[", "//\\\\//\\\\", "|\\/|", "/\\/\\", "(u)", "(V)", "(\\/)", "/|\\", "^^", "/|/|", "//.", ".\\\\", "/^^\\", "/V\\", "[]\\/[]" ] ],
		'n'		:	[ [  ],					[ "|\\|", "^/", "//\\\\//", "/\\/", "[\\]", "<\\>", "{\\}", "[]\\", "// []", "/V", "₪", "[]\\[]" ] ],
		'o'		:	[ [ '0' ],				[ "()", "oh", "[]", "¤", "Ω" ] ],
		'p'		:	[ [ '9' ],				[ "|*", "|o", "|º", "|^(o)", "|>", "|\"", "?", "[]D", "|̊", "|7", "þ", "¶" ] ],
		'q'		:	[ [  ],					[ "(_,)", "()_", "0_", "<|" ] ],
		'r'		:	[ [ '2', '®' ],			[ "|?", "/2", "I2", "|^", "|~", "lz", "|2", "[z", "12", "l2", "Я", "|2", "ʁ" ] ],
		's'		:	[ [ '5', '$' ],			[ '$', 'z', '§', "ehs", "es" ] ],
		't'		:	[ [ '7', '1' ],			[ '+', "-|-",  "']['", "†" ] ],
		'u'		:	[ [ 'v' ],				[ "(_)", "|_|", "L|" ] ],
		'v'		:	[ [  ],					[ "\\/", "√", "\\\\//" ] ],
		'w'		:	[ [  ],					[ "vv", "\\/\\/", "'//", "\\\\'", "\\^/", "(n)", "\\V/", "\\X/", "\\|/", "\\_|_/", "\\_:_/", "(/\\)", "Ш", "ɰ" ] ],
		'x'		:	[ [  ],					[ "%", "><", "Ж", "}{", "ecks", "×", "*", ")(" ] ],
		'y'		:	[ [ 'j' ],				[ "`/", "Ψ", "φ", "λ", "Ч", "¥" ] ],
		'z'		:	[ [  '2' ],				[ "~/_", "%", ">_", "ʒ", "7_" ] ],
		
	},


	/* getRandomName
	*  gets a new random name from the prefs
	*/
	getRandomName: function(strPref) {
		var splitter = '|';
		//seperators are seperated by ',' not by '|'
		if (strPref.indexOf("seperators") > 0 )
			splitter = ',';
			
		try {
			var arrNames = ThunderSomething.getPref(strPref).split(splitter);
		}catch (ex){
			return " ";
		}
		var ret = arrNames[this.Rnd(arrNames.length - 1)];
		
		return ret;
	},
	

	
	Rnd: function(max) {
		max = parseInt(max);
		return Math.round(max * Math.random());
	},


	setNames: function(){
		
		var post =   ThunderSomething.getPref('extensions.thundersomething.postprocess');

		//get some new random names
		var pvendor = this.getRandomName("extensions.thundersomething.lists.vendors");
		var pspacer = this.getRandomName("extensions.thundersomething.lists.spacers");
		var pprefix = this.getRandomName("extensions.thundersomething.lists.prefixes");
		var psuffix = this.getRandomName("extensions.thundersomething.lists.names");
		var pcomment = this.getRandomName("extensions.thundersomething.lists.comments");
		var psep = ' ' + this.getRandomName("extensions.thundersomething.lists.seperators") + ' ';
//		dump('Title B4 mangling: '+pvendor+pspacer+pprefix+psuffix+pcomment+"\n");
	
		//do the postprocess mangling
		if ( post == 'camel'){
		
			psuffix = psuffix[0].toUpperCase() + psuffix.substr(1);
			
		}else if (post != 'none'){
			pvendor = this.RandString(pvendor, post);
			pprefix = this.RandString(pprefix, post);
			psuffix = this.RandString(psuffix, post);
			pcomment = this.RandString(pcomment, post);
		}
		
		LastTitle = TitleName;
		LastSep = Seperator;
		
		//and set the vars
		Vendor = pvendor;
		ShortName = pprefix + psuffix;
		TitleComment = pcomment;
		TitleName = pvendor + pspacer + ShortName + pcomment;
		Seperator = psep;
		dump('Setting title to: '+TitleName+"\n");
		
	},


	RandString: function(str, func){
		var i = 0, out = '', c, o;
		
		for (i=0; i < str.length; i++){
			c = str[i].toLowerCase();
			o = c;
			
//			dump("RndStr Working on char: "+o+"\n");
			switch (func){
				case 'u1337':
//					dump("RndStr(u1337) Working on char: "+o+"\n");
					if (this.Rnd(2))
						o = this.strtr(c, this.tr1337[c][1]);

				case '1337':
//					dump("RndStr(1337) Working on char: "+o+"\n");
					if (this.Rnd(1) && this.tr1337[c])
						o = this.strtr(c, this.tr1337[c][0]);
				case 'rcase':
//					dump("RndStr(rcase) Working on char: "+o+"\n");
					if (this.Rnd(1))
						o = o.toUpperCase() ;
					break;
				
				default:
				case 'none':
				case 'camel':
					break;
				
			}
			out += o;
		}
//		dump("RndStr returning char: "+out+"\n");

		return out;
	},
	

	//takes a char and an array with possible translations.
	strtr: function(c, a){
		var ret;
		if (a.length > 0)
			ret = a[ this.Rnd(a.length-1) ];	
		
		if (!ret)
			ret = c;
			
//		dump("strtr returning: "+ret+"\n");
		return ret;
	}, 


}

