// Thundersomething extension for Mozilla Thunderbird
// Copyright (C) 2004-2007  Michael O'Rourke / Cosmic Cat Creations (http://www.cosmicat.com/)
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

const TSName = "ThunderSomething";
const TSVer = "0.9.6";

var OriginalBrand = '';
var OriginalVersion = '';	
var RebrandWnd = false;
var DefaultAbout = '';
var DefaultName = '';

var ThunderSomething = {

	
	/* init
	*  inits this obj: sets some listeners and vars
	*/
	init: function() {
		this.Prefs = new ThunderSomething_PrefManager();
		DefaultName = document.getElementById("messengerWindow").getAttribute("titlemodifier");
		this.initUserAgentStuff();
		
		
//		var bSameName = this.getPref("extensions.thundersomething.samename");
/*
		if (bSameName) {
			var arrWin = this.getOtherWindows();
			if (arrWin.length > 0) {
//				var oTS = arrWin[0].ThunderSomething;
				this.setNewBrowserName(Vendor, ShortName, TitleComment, Seperator);
			} else {
				this.setNames();
			}
		} else {
			
		}
		*/
		this.setNames();
		window.addEventListener("focus", function() { ThunderSomething.setUserAgent(); }, false);
		this.Prefs.addPrefObserver("ThunderSomething.prefObserver");
	},
	
	/* init2
	*  adds the window listener and updates the titlebar
	*/
	init2: function() {
		try{
			document.getElementById("messengerWindow").addEventListener("DOMTitleChanged", ThunderSomething.updateTitlebar, false);  
		}catch(ex){ dump(ex + "\n"); }
		this.updateTitlebar();
		DefaultAbout = document.getElementById("aboutName").getAttribute("label");
		setTimeout("ThunderSomething.setDelayedNames();", 100);
	},
	
	/* destruct
	*  destroys this obj
	*/
	destruct: function() {
		try { this.Prefs.removePrefObserver(); } catch(ex) {}
	},
	
	/* getPref
	*  returns a preference variable, by using the _prefManager obj
	*/
	getPref: function(strName) {
		return this.Prefs.getPref(strName);
	},
	
	getDefaultAbout: function(){
		return DefaultAbout;	
	},
	getDefaultName: function(){
		return DefaultName;	
	},
	getShortName: function(){
		return ShortName;	
	},
	
	
	/* prefObserver
	*  gets called when one of our prefs gets changed
	*/
	prefObserver: function(subject, topic, prefName) {
		switch (prefName) {
			case "extensions.thundersomething.images.about":
			case "extensions.thundersomething.images.throbber1":
			case "extensions.thundersomething.images.throbber2":
				return;
			default: this.setNames();
		}
	},
	
	/* setNames
	*  gets a new random name and inits all setting routines
	*/
	setNames: function() {
//		var bSameName = this.getPref("extensions.thundersomething.samename");
//		var bTopWin = (window == this.getWM().getMostRecentWindow(null));
//		if (bSameName && !bTopWin) { return; }

		TS_NameManager.setNames();
		
		//this.setNewBrowserName(vendor + spacer, prefix + suffix, comment, sep);
		this.setNewBrowserName();
		//if (bSameName) { this.updateOtherWindows(); }
		//if (bTopWin) { 
			this.setUserAgent(); 
		//}
	},
	
	/* setNewBrowserName
	*  appends the current random name to the end of the current window's title
	*/
	//setNewBrowserName: function(strVendor, strShortName, strTitleComment, sep) {
	setNewBrowserName: function() {
		var newtit = document.getElementById("messengerWindow").title + Seperator + TitleName;
		
		try{ document.getElementById("messengerWindow").setAttribute("titlemodifier", TitleName); }catch(ex) {dump(ex+"\n"); }
		try { document.getElementById("messengerWindow").setAttribute('title', newtit); } catch(ex) { dump(ex + "\n"); }
		try{ document.getElementById("messengerWindow").titlemodifier = TitleName; }catch(ex) {dump(ex+"\n"); }
		try { document.getElementById("messengerWindow").title = newtit; } catch(ex) { dump(ex + "\n"); }
		
		
		if (RebrandWnd){
			try{ document.title += TitleName; }catch(ex) {dump(ex+"\n"); }
		}
		
		this.updateTitlebar();
		setTimeout("ThunderSomething.setDelayedNames();", 100);
	},
	
	/* setDelayedNames
	*  changes the label in the about box
	*/
	setDelayedNames: function() {
		try {
			this.updateTitlebar();
		} catch(ex) { dump(ex + "\n"); }
	},
	
	/* updateTitlebar
	*  actually changes the titlebar
	*	gets called whenever the DOMTitle changes
	*/
	updateTitlebar: function() {
		var doc = document.title;
//		dump('setting title to: '+Seperator+TitleName+', old Title is: ' + doc + ", lasttitle was: " + LastTitle + "\n");
		//get the wnd title w/out the lasttitle in it
		if (LastTitle && doc.indexOf(LastTitle) != -1){
			document.title = doc.substring(0, doc.indexOf(LastTitle) - LastSep.length);
		}

		if (RebrandWnd && (document.title.indexOf(TitleName) == -1)) {			// && (document.title.indexOf(LastTitle) == -1)){
			try { document.title += Seperator + TitleName; } catch(ex) { dump(ex + "\n"); }
		}
	},
	
	/* initUserAgentStuff
	*  gets the original name and saves it
	*  sets all the prefs accordingly, that is set or clear the XMailer header
	*/
	initUserAgentStuff: function() {
		var originalBrandVersion = this.Prefs.getService().getDefaultBranch(null)
				.getCharPref("general.useragent.extra.thunderbird");
				
		var myRegExp = new RegExp("\/", "");
		if (myRegExp.test(originalBrandVersion)) {
			OriginalBrand = RegExp.leftContext;
			OriginalVersion = RegExp.rightContext;
		}
		//and init X-mailer header override
		var vheaders = this.getPref("mail.identity.default.headers");
		var xheader = this.getPref("mail.identity.default.header.xmailer");
		var rebrandxheader = this.getPref("extensions.thundersomething.xmailer.rebrand");
		
		if (rebrandxheader){
			//set the xmailer header only if not already set
			if (vheaders.indexOf('xmailer') == -1){
				if (vheaders){
					vheaders = vheaders + "," + "xmailer";
				}else{
					vheaders = "xmailer";
				}
				this.Prefs.setPref("mail.identity.default.headers", vheaders);
			}
		}else{
			//clear the extension header
			if (vheaders.indexOf('xmailer') != -1){
				var parts = vheaders.split(',');
				var idx = parts.indexOf('xmailer');
				parts.splice(idx, 1);
				this.Prefs.setPref("mail.identity.default.headers", parts.join(','));
			}
		}

		RebrandWnd = this.getPref("extensions.thundersomething.window.rebrand");

		
	},
	
	/* setUserAgent
	*  builds the useragent string
	*  sets all the prefs accordingly, i.e. set the name into the right pref for overrriding the useragent tag and header
	*/
	setUserAgent: function() {

		var userAgentTag = "";
		
		userAgentTag += ShortName + "/" + OriginalVersion;
		var shortHeader = userAgentTag;

		var comment = this.getPref("extensions.thundersomething.useragent.comment");
		if (comment) {
			comment = comment.replace(/#name#/g, OriginalBrand);
			comment = comment.replace(/#version#/g, OriginalVersion);
			comment = comment.replace(/#TSVersion#/g, TSVer);
			comment = comment.replace(/#TSName#/g, TSName);
			userAgentTag += " (" + comment + ")";
		}
		var longHeader = TitleName + " (" + comment + ")";
		
		if (this.getPref("extensions.thundersomething.useragent.rebrand")) {
			this.Prefs.setPref("general.useragent.extra.thunderbird", userAgentTag);			//set the HTTP req user-agent string to "shortname/version (useragent-comment)"
		} else {
			try { this.Prefs.setPref("general.useragent.extra.thunderbird", ''); } catch(ex) {}
		}
		
		if (this.getPref("extensions.thundersomething.mail_useragent.rebrand")) {
			this.Prefs.setPref("general.useragent.override", shortHeader);						//set the User-Agent: header field to the "shortname/version"
		} else {
			try { this.Prefs.getRootBranch().clearUserPref("general.useragent.override"); } catch(ex) {}
		}

		if (this.getPref("extensions.thundersomething.xmailer.rebrand")) {
			this.Prefs.setPref("mail.identity.default.header.xmailer", "X-Mailer: "+TitleName);						//set the X-Mailer: header field to "Vendor Shortname/Version (TitleName-Comment)"
		} else {
			try { this.Prefs.getRootBranch().clearUserPref("mail.identity.default.header.xmailer"); } catch(ex) {}
		}
		
		//and init X-mailer header override
		var vheaders = this.getPref("mail.identity.default.headers");
		var xheader = this.getPref("mail.identity.default.header.xmailer");
		var rebrandxheader = this.getPref("extensions.thundersomething.xmailer.rebrand");
		
		if (rebrandxheader){
			if (vheaders.indexOf('xmailer') == -1){
				if (vheaders){
					vheaders = vheaders + "," + "xmailer";
				}else{
					vheaders = "xmailer";
				}
				this.Prefs.setPref("mail.identity.default.headers", vheaders);
			}
		}else{
			//and clear the extension header
			if (vheaders.indexOf('xmailer') != -1){
				var parts = vheaders.split(',');
				var idx = parts.indexOf('xmailer');
				parts.splice(idx, 1);
				this.Prefs.setPref("mail.identity.default.headers", parts.join(','));
			}
			
		}

		RebrandWnd = this.getPref("extensions.thundersomething.window.rebrand");
			

	},
	
	
	/* updateOtherWindows
	*  get other windows of this instance and set their names also
	*/
	/*
	updateOtherWindows: function() {
		var arrWin = this.getOtherWindows();
		for (var i=0; i < arrWin.length; i++) {
			try { arrWin[i].ThunderSomething.setNewBrowserName(Vendor, ShortName, TitleComment, Seperator); } catch(ex) { dump(ex + "\n"); }
		}
	},
	
	/* getOtherWindows
	*  try to get other windows of this instance
	*/
	/*getOtherWindows: function() {
		var hWin, arrWin = new Array();
		var e = this.getWM().getEnumerator(null);
		while (e.hasMoreElements()) {
			hWin = e.getNext();
			if (hWin == window) { continue; }
			if (hWin.document.getElementById("msgcomposeWindow")) { arrWin[arrWin.length] = hWin; }
		}
		return arrWin;
	},
	
	/* getWM
	*  gets the window mediator class for mozilla
	*/
	/*getWM: function() {
		return Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	},
	*/
}


/* init this instance and register it
*/


ThunderSomething.init();
window.addEventListener("load", function() { ThunderSomething.init2(); }, false);
window.addEventListener("unload", function() { ThunderSomething.destruct(); }, false);

